#!/bin/sh

if [ -z "$GF_DOMAIN_DIR" ]; then
    echo "Please set environment variable GF_DOMAIN_DIR ..." >&2
    exit 1
fi

mvn clean install

find . -iwholename "*/target/*.[jw]ar" -exec cp -v {} "$GF_DOMAIN_DIR/autodeploy/bundles/" \;

getCount()
{
    sed -n 's/^\s\+UserServiceWS\s\+listening.*\(http[^\|]\+\).*$/\1/gp' "${GF_DOMAIN_DIR}/logs/server.log" | wc -l
}

dcount=`getCount`

while [ "`getCount`" -eq "$dcount" ]; do
    echo "Waiting for (re-)deployment..."
    sleep 5
done

echo "Testing web service..."

ws_url="`sed -n 's/^\s\+UserServiceWS\s\+listening.*\(http[^\|]\+\).*$/\1/gp' "${GF_DOMAIN_DIR}/logs/server.log" | tail -1`"

echo "Calling the web service (expecting a fault):"
fault="`curl -H 'content-type:text/xml' -d@soap-request.xml "$ws_url" 2>/dev/null | grep '<S:Fault'`"

if [ -z "$fault" ]; then
    echo "FAILED: No fault detected. Web service call executed an EJB method although unauthorized. :(" >&2
    exit 1
fi

echo "SUCCESS: I have been intercepted! :)"
