/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.glassfish.cditest.security.interceptor;

import java.lang.reflect.Method;
import java.security.Principal;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.annotation.Resource;
import javax.ejb.EJBContext;
import javax.interceptor.AroundInvoke;
import javax.interceptor.Interceptor;
import javax.interceptor.InvocationContext;

import java.io.Serializable;
import org.glassfish.cditest.security.api.InterceptorSecurityException;
import org.glassfish.cditest.security.api.Secure;

/**
 * Realizes security for EJBs.
 * 
 * @author chaoslayer
 * 
 */
@Secure
@Interceptor
public class SecurityInterceptor implements Serializable
{
    private static final Logger LOG = Logger.getLogger(SecurityInterceptor.class.getName());
    
    @Resource
    private EJBContext ejbCtx;
    
    /**
     * Perform lookup for permissions.
     * Does the caller has the permission to call the method?
     * 
     * @param InvocationContext of intercepted method
     * @return
     * @throws Exception
     */
    @AroundInvoke
    protected Object invoke(final InvocationContext ctx) throws Exception
    {
        Principal p = ejbCtx.getCallerPrincipal();
        Method interfaceMethod = ctx.getMethod();
        Class target = ctx.getTarget().getClass();
        
        LOG.log(Level.INFO, "EJB Method called:\"{0}\" by Principal:{1}",
                new Object[]{target.getSimpleName() + "::" + interfaceMethod.getName() + "()", p.toString()});
        
        if(true) {
            throw new InterceptorSecurityException("Unauthorized access to "
                    + ctx.getTarget().getClass().getSimpleName() + "::" + interfaceMethod.getName() + "()");
        }
        
        return ctx.proceed();
    }
}
