package org.glassfish.cditest.user.impl.ws;

import javax.inject.Inject;
import org.glassfish.cditest.user.impl.ws.client.UserClient;
import javax.jws.WebMethod;
import javax.jws.WebService;
import org.glassfish.cditest.user.api.UserService;
import org.glassfish.cditest.user.api.model.User;
import org.glassfish.cditest.user.model.UserImpl;
import org.glassfish.osgicdi.OSGiService;

@WebService()
public class UserServiceWS
{

    @Inject
    @OSGiService(dynamic = true)
    private UserService svc;

    @WebMethod
    public UserClient findById(long arg0) throws UserServiceFaultException {
        UserClient result = null;

        try {
            User u = svc.findById(arg0);

            result = new UserClient();
            result.setId(u.getId());
            result.setUsername(u.getUsername());
            result.setEmailAddress(u.getEmailAddress());
            result.setFirstName(u.getFirstName());
            result.setLastName(u.getLastName());
            result.setGender(u.getGender());
        } catch (Exception ex) {
            throw new UserServiceFaultException(ex.getMessage(), ex);
        }

        return result;
    }

    @WebMethod
    public Long addUser(UserClient arg0) throws UserServiceFaultException {
        Long result = null;

        try {
            UserImpl u = new UserImpl();
            u.setUsername(arg0.getUsername());
            u.setEmailAddress(arg0.getEmailAddress());
            u.setFirstName(arg0.getFirstName());
            u.setLastName(arg0.getLastName());
            u.setGender(arg0.getGender());

            result = svc.addUser(u);
        } catch (Exception ex) {
            throw new UserServiceFaultException(ex.getMessage(), ex);
        }

        return result;
    }
}
